// INF555, Frank Nielsen

import javax.media.opengl.*;
import processing.opengl.*;
import com.sun.opengl.util.FPSAnimator;

PGraphicsOpenGL pgl;
GL gl;

void setup() {
 size(512, 512, OPENGL);
  colorMode(RGB, 1.0, 1.0, 1.0);
  pgl = (PGraphicsOpenGL) g;
  gl = pgl.beginGL();
 Frame f = new Frame("New window: OpenGL(R) frame");
 GLCanvas canvas = new GLCanvas();
 canvas.addGLEventListener(new GLRenderer());
 f.add(canvas);
 f.setSize(512,512);
 f.setLocation(0,0);
 f.setUndecorated(false);
 f.show();
 FPSAnimator animator = new FPSAnimator(canvas, 60);
 animator.start();
}

void draw() {
 background(0);
 pgl.beginGL();  
  gl.glMatrixMode(GL.GL_PROJECTION);
  gl.glLoadIdentity();
  gl.glOrtho(0,1,0,1,-1000,1000);

  gl.glMatrixMode(GL.GL_MODELVIEW);
  gl.glLoadIdentity();
  gl.glColor3f(0,0,0);
  gl.glPointSize(5.0);
  
  gl.glBegin(GL.GL_POINTS);
  for(int i=1; i<100; i++){
      gl.glColor3f((float)Math.random(),(float)Math.random(),(float)Math.random());
      gl.glVertex2f((float)Math.random(), (float)Math.random()); 
  
  }
  gl.glEnd();
  pgl.endGL();
}

class GLRenderer implements GLEventListener {
 GL gl;

 public void init(GLAutoDrawable drawable) {
   this.gl = drawable.getGL();
   gl.glClearColor(0, 0, 0, 0);
 }

 public void display(GLAutoDrawable drawable) {
   gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT );
  
   
  gl.glMatrixMode(GL.GL_PROJECTION);
  gl.glLoadIdentity();
  gl.glOrtho(0,1,0,1,-1000,1000);

  gl.glMatrixMode(GL.GL_MODELVIEW);
  gl.glLoadIdentity();
  gl.glColor3f(0,0,0);
  gl.glPointSize(5.0);
  
  gl.glBegin(GL.GL_POINTS);
  for(int i=1; i<100; i++){
     gl.glColor3f((float)Math.random(),(float)Math.random(),(float)Math.random());
      gl.glVertex2f((float)Math.random(), (float)Math.random()); 
  }
  gl.glEnd();
   
 }
 
 public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
 }

 public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged) {
 }
}
